SoVRMLPlaneSensor(3)

NAME
SoVRMLPlaneSensor - The SoVRMLPlaneSensor class maps pointer motion into object space translations.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLPlaneSensor>

Inherits SoVRMLDragSensor.

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLPlaneSensor (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFVec2f minPosition
SoSFVec2f maxPosition
SoSFVec3f offset
SoSFVec3f translation_changed

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual SbBool dragStart (void)
virtual void drag (void)
virtual void dragFinish (void)
virtual ~SoVRMLPlaneSensor ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLPlaneSensor class maps pointer motion into object space translations. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

PlaneSensor {
  exposedField SFBool  autoOffset          TRUE
  exposedField SFBool  enabled             TRUE
  exposedField SFVec2f maxPosition         -1 -1     # (-,)
  exposedField SFVec2f minPosition         0 0       # (-,)
  exposedField SFVec3f offset              0 0 0     # (-,)
  eventOut     SFBool  isActive
  eventOut     SFVec3f trackPoint_changed
  eventOut     SFVec3f translation_changed
}

The PlaneSensor node maps pointing device motion into two-dimensional translation in a plane parallel to the Z=0 plane of the local coordinate system. The PlaneSensor node uses the descendent geometry of its parent node to determine whether it is liable to generate events.

The enabled exposedField enables and disables the PlaneSensor. If enabled is TRUE, the sensor reacts appropriately to user events. If enabled is FALSE, the sensor does not track user input or send events.

If enabled receives a FALSE event and isActive is TRUE, the sensor becomes disabled and deactivated, and outputs an isActive FALSE event.

If enabled receives a TRUE event, the sensor is enabled and made ready for user activation.

The PlaneSensor node generates events when the pointing device is activated while the pointer is indicating any descendent geometry nodes of the sensor's parent group. See 4.6.7.5, Activating and manipulating sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.5), for details on using the pointing device to activate the PlaneSensor.

Upon activation of the pointing device (e.g., mouse button down) while indicating the sensor's geometry, an isActive TRUE event is sent. Pointer motion is mapped into relative translation in the tracking plane, (a plane parallel to the sensor's local Z=0 plane and coincident with the initial point of intersection). For each subsequent movement of the bearing, a translation_changed event is output which corresponds to the sum of the relative translation from the original intersection point to the intersection point of the new bearing in the plane plus the offset value. The sign of the translation is defined by the Z=0 plane of the sensor's coordinate system.

trackPoint_changed events reflect the unclamped drag position on the surface of this plane. When the pointing device is deactivated and autoOffset is TRUE, offset is set to the last translation_changed value and an offset_changed event is generated. More details are provided in 4.6.7.4, Drag sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.4).

When the sensor generates an isActive TRUE event, it grabs all further motion events from the pointing device until it is deactivated and generates an isActive FALSE event. Other pointing-device sensors shall not generate events during this time. Motion of the pointing device while isActive is TRUE is referred to as a 'drag'.

If a 2D pointing device is in use, isActive events typically reflect the state of the primary button associated with the device (i.e., isActive is TRUE when the primary button is pressed, and is FALSE when it is released).

If a 3D pointing device (e.g., wand) is in use, isActive events typically reflect whether the pointer is within or in contact with the sensor's geometry.

minPosition and maxPosition may be set to clamp translation_changed events to a range of values as measured from the origin of the Z=0 plane. If the X or Y component of minPosition is greater than the corresponding component of maxPosition, translation_changed events are not clamped in that dimension. If the X or Y component of minPosition is equal to the corresponding component of maxPosition, that component is constrained to the given value. This technique provides a way to implement a line sensor that maps dragging motion into a translation in one dimension.

While the pointing device is activated and moved, trackPoint_changed and translation_changed events are sent. trackPoint_changed events represent the unclamped intersection points on the surface of the tracking plane. If the pointing device is dragged off of the tracking plane while activated (e.g., above horizon line), browsers may interpret this in a variety ways (e.g., clamp all values to the horizon). Each movement of the pointing device, while isActive is TRUE, generates trackPoint_changed and translation_changed events. Further information about this behaviour can be found in 4.6.7.3, Pointing-device sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.3), 4.6.7.4, Drag sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.4), and 4.6.7.5, Activating and manipulating sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.5).

Constructor & Destructor Documentation

  SoVRMLPlaneSensor::SoVRMLPlaneSensor (void)
Constructor.

  SoVRMLPlaneSensor::~SoVRMLPlaneSensor () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLPlaneSensor::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLPlaneSensor::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoVRMLDragSensor.

  const SoFieldData ** SoVRMLPlaneSensor::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLPlaneSensor::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoVRMLDragSensor.

  void SoVRMLPlaneSensor::initClass (void) [static]

  SbBool SoVRMLPlaneSensor::dragStart (void) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Called when dragger is selected (picked) by the user.

Implements SoVRMLDragSensor.

  void SoVRMLPlaneSensor::drag (void) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Called when user drags the mouse after picking the dragger.

Implements SoVRMLDragSensor.

  void SoVRMLPlaneSensor::dragFinish (void) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Called when mouse button is released after picking and interacting with the dragger.

Implements SoVRMLDragSensor.

Member Data Documentation

  SoSFVec2f SoVRMLPlaneSensor::minPosition
The minimum position. Initial value is [0, 0].

  SoSFVec2f SoVRMLPlaneSensor::maxPosition
The maximum position. Initial value is [-1, -1].

  SoSFVec3f SoVRMLPlaneSensor::offset
Current position. Initial value is [0, 0, 0].

  SoSFVec3f SoVRMLPlaneSensor::translation_changed
An eventOut that is sent during interaction.

Author

Generated automatically by Doxygen for Coin from the source code.